/*************************************************************************************
Mat 259 Project 2 3D Visualization: "Mental Health from Checkouts over time"               
Tested in Processing 4                                  
                                                     
Author: Jing Peng                       
Supervisor: George Legrady                           

Purpose: Show how to present volume data in a basic 3D environment     

Usage: 1. A mouse left-drag will rotate the camera around the subject.
          2. A right drag will zoom in and out. 
          3. A middle-drag (command-left-drag on mac) will pan. 
          4. A double-click restores the camera to its original position. 
          5. The shift key constrains rotation and panning to one axis or the other.
*************************************************************************************/

import peasy.*;
import controlP5.*;

PeasyCam cam;
ControlP5 cp5;

PFont font;


int startYear = 2006;
int endYear = 2023;

float radiusMultiplier = 100; // Multiplier for percentage-based radius
float minRadius = 100; // Minimum radius for points
float maxRadius = 300; // Maximum radius for points
float Radius = 200;
float radius;
PVector[] points;
color[] categoryColors;
int[] kind;


Table table;
int numRows, numColumns;

ArrayList<Category> categories = new ArrayList<Category>();
// Map<Integer, ArrayList<Category>> map = new HashMap<Integer,ArrayList<Category>>();

void setup() {
  size(1000, 800, P3D);
  font = createFont("Arial", 100);
  cam = new PeasyCam(this, 750);
  // cam.setMinimumDistance(50);
  // cam.setMaximumDistance(800);
  cp5 = new ControlP5(this);
  
  categoryColors = new color[5];

  loadData();

  categoryColors[0] = color(255, 0, 0); // Red
  categoryColors[1] = color(0, 255, 0); // Green
  categoryColors[2] = color(0, 0, 255); // Blue
  categoryColors[3] = color(255, 255, 0); // Yellow
  categoryColors[4] = color(255, 0, 255); // Yellow

}

void draw() {

  background(56, 48, 60);
  gui();

  noFill();
  stroke(0);
  int cur = 500;

  drawCircleAndText();

  for(int k = 0; k < 5 ; k++){
  // translate(cur+100, 0, 0);
    drawPoints(k);
  // drawLines(k);
    //drawLabels();
    //drawVertex(k);
    
  }
  

  //if((mouseX<180) & (mouseY<180)) {
  //  cam.setActive(false);
  //} else {
  //  cam.setActive(true);
  //}

}

void gui() {
   hint(DISABLE_DEPTH_TEST);
   cam.beginHUD();
   cp5.draw();
   cam.endHUD();
   hint(ENABLE_DEPTH_TEST);
}
